# Start of  Bilko for Windows formula document to atmospherically correct Landsat-5 TM bands 
# 1-3 collected over the Turks and Caicos on 22 November 1990.
#
#	Formula document 2.
#	=================
#
# 	Stage 2 of atmospheric correction using 5S radiative transfer model outputs
#
#	Input values
#	==========
# 	AI = 1 / (Global gas transmittance * Total scattering transmittance)
#		TM1 = 1.3056, TM2 = 1.2769, TM3 = 1.1987
#
# 	BI = - Reflectance / Total scattering transmittance
#		TM1 = -0.0992, TM2 = -0.0515, TM3 = -0.0301 
#
	const AI1 = 1.3056 ;
	const AI2 = 1.2769 ;
	const AI3 = 1.1987 ;

	const BI1 = -0.0992 ;
	const BI2 = -0.0515 ;
	const BI3 = -0.0301 ;

#	Let exoatmospheric reflectance = @n   (i.e. images output by first formula document)
#
#	Converting exoatmsopheric reflectance (scale 0-1) to intermediate image Y with formulae of the type:
#
#		 AI * @n + BI;
#
#	Intermediate formulae for Y:
# 
#	AI1 * @1  + BI1;
#	AI2 * @2  + BI2;
#	AI3 * @3  + BI3;
#
# 	Stage 3 of atmospheric correction using 5S radiative transfer model outputs
#
#	Input values
#	==========
# 	S = Spherical albedo: TM1 = 0.156, TM2 = 0.108, TM3 = 0.079
#
	const S1 = 0.156 ;
	const S2 = 0.108 ;
	const S3 = 0.079 ;

#	Let intermediate image  = Y  (see intermediate formulae above)
#
#	Converting Y to surface reflectance (on scale 0-1) with formulae of the type:
#
#		Y / (1 + S * Y)  ;
#
# 	Note that the intermediate formula for Y should appear in the equation twice.
#

	(AI1 * @1 + BI1) / (1 + S1 * (AI1 * @1 + BI1) )  ;
	(AI2 * @2 + BI2) / (1 + S2 * (AI2 * @2 + BI2) )  ;
	(AI3 * @3 + BI3) / (1 + S3 * (AI3 * @3 + BI3) )  ;

